<!-- 商品分类树形选择  -->
<template>
  <div>
    <el-dialog :append-to-body="true" :close-on-click-modal="false" title="选择商品分类" :visible.sync="Show" width="500px">
      <div class="mb20">
        <el-input placeholder="输入关键字进行过滤" v-model="filterText">
        </el-input>
      </div>
      <div class="treeBox">
        <el-tree ref="tree" :filter-node-method="filterNode" :check-strictly="true" :default-expanded-keys="valueArray" :data="options" show-checkbox node-key="id" :props="defaultProps">
        </el-tree>
      </div>
      <div slot="footer">
        <el-button type="primary" @click="handelSetMenu">确 定</el-button>
        <el-button type="danger" @click="reset">重 置</el-button>
        <el-button @click="dialogClose">关 闭</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>

export default {
  name: 'goodsClassTree',
  props: {
    show: {
      required: true,
      type: Boolean,
    },

    ids: {
      type: Array,
    },
  },

  watch: {
    filterText(val) {
      this.$refs.tree.filter(val);
    }
  },

  computed: {
    Show: {
      get() {
        return this.show
      },
      set(v) {
        this.$emit('update:show', v)
      }
    }
  },
  data() {
    return {
      filterText: '',
      m_tableLoading: false,
      options: [],
      valueArray: [],
      defaultProps: {
        children: 'children',
        label: 'name'
      },

    }
  },

  mounted() {
    this.init()
  },

  methods: {
    //初始化方法
    init() {
      this.getDataList()
    },

    getDataList() {
      this.m_api.goods_categories().then(res => {
       console.log(res.data)
        this.options = res.data
        this.handleValue()
      })
    },

    reset() {
      this.$refs.tree.setCheckedKeys([])
    },

    dialogClose() {
      this.Show = false
    },

    getCheckedNodes() {
      return this.$refs.tree.getCheckedNodes()
    },
    getCheckedKeys() {
      return this.$refs.tree.getCheckedKeys()
    },
    handleValue() {
      this.valueArray = [...this.ids]
      this.$refs.tree.setCheckedKeys([...this.ids])
    },

    handelSetMenu() {
      this.$emit('saveAfter', this.getCheckedNodes())
      this.Show = false
    },

    filterNode(value, data) {
      if (!value) return true;
      return data.name.indexOf(value) !== -1;
    }

  },

  filters: {

  }
}

</script>
<style lang='scss' scoped>
.treeBox {
  height: 450px;
  overflow: auto;
  border: 1px solid #eee;
}
</style>